#!/usr/bin/perl
# -------------------------------------------------------------------------
# Hamnet IP database - Generate /etc/hosts
#
# Flori Radlherr, DL8MBT, http://www.radlherr.de
#
# Licensed with Creative Commons Attribution-NonCommercial-ShareAlike 3.0
# http://creativecommons.org/licenses/by-nc-sa/3.0/
# - you may change, distribute and use in non-commecial projects
# - you must leave author and license conditions
# -------------------------------------------------------------------------
#
push @INC,'.';
do "lib.cgi" or die;
#
my $suffix=  lc $query->param("suffix");
$suffix= "" unless $suffix;
$suffix=~s/[^a-z0-9\.\-]//g;
$suffix=~s/^\.//;

print("Content-Type: text/plain\n");
print("Content-Disposition: attachment; filename=hosts\n\n");

print("# /etc/hosts generated by Hamnet-DB\n");
print("# Get recent version from http://hamnetdb.net/\n");
print("#\n127.0.0.1       localhost\n");

my $sth= $db->prepare(qq(
  select name,ip,aliases
  from hamnet_host
));
$sth->execute;

while (@line= $sth->fetchrow_array) {
  my $idx= 0;
  my $name= $line[$idx++];
  my $ip= $line[$idx++];
  my $aliases= $line[$idx++];

  foreach $alias (split(/[,; ]+/, $aliases)) {
    $allNames{$alias}= $ip;
  }
  $allNames{$name}= $ip;
}

my $sth= $db->prepare(qq(
  select id,name,ip,aliases
  from hamnet_host order by rawip
));
$sth->execute;

while (@line= $sth->fetchrow_array) {
  my $idx= 0;
  my $id= $line[$idx++];
  my $name= $line[$idx++];
  my $ip= $line[$idx++];
  my $aliases= $line[$idx++];
  $aliases=~s/[,;]/ /g;

  if ($name=~/^(web|router|hr)\.([a-z0-9]+)$/) {
    my $site= $2;
    unless ($allNames{$site}) {
      $aliases.= " " if $aliases;
      $aliases.= $site;
      $allNames{$site}= $ip;
    }
  }

  my $names= "";
  foreach $alias (($name,split(/[,; ]+/, $aliases))) {
    $names.= " $alias.ampr.org $alias";
    if ($suffix) {
      $names.= " $alias.$suffix";
    }
  }

  printf("%-15s$names\n",$ip);
}
